#lang racket
(require racklog)

(define %coffee
  (%rel ()
        [('moka)]
        [('turkish)]
        [('expresso)]
        [('cappuccino)]
        [('latte)]))

(define %member
  (%rel (x xs)
        [(x (cons x (_)))]
        [(x (cons (_) xs))
         (%member x xs)]))

(%which (m) (%member m '(1 2 3)))
(%more)
(%more)
(%more)

(define %parent
  (%rel ()
        [('Wilma 'Pebbles)]
        [('Fred 'Pebbles)]
        [('Homer 'Bart)]
        [('Homer '(Jack Joe))]
        [('Dick 'Harry)]
        [('William 'Henry)]
        [('Henry 'John)]
        [('Marge 'Bart)]
        [('Marge 'Maggie)]
        [('Marge 'Lisa)]
        [('Tom 'Dick)]
        [('Tim 'Sue)]))

(%assert! ; adds clause after other clauses
 %parent () [('Tim 'Rick)])
(%assert-after!  ; adds clause before other clauses
 %parent () [('Rose 'Rick)])


(%which (x) (%parent x 'Maggie))
(%which (x) (%parent 'Homer x))
(%more)
(define t (%more))
(%more)

(define %grand
  (%rel (g p c)
        [(g c)
         (%parent g p) (%parent p c)]))

(%which (g c) (%grand g (_)))
(%more)
(%more)

(define %reverse
  (letrec
      ([revaux
        (%rel (x y z w)
              [('() y y)]
              [((cons x y) z w)
               (revaux y
                       (cons x z) w)])])
    (%rel (x y)
          [(x y) (revaux x '() y)])))


