#lang racket
(require racklog)

(define %member
  (%rel (x y)
        [(x (cons x (_)))]
        [(x (cons (_) y) (%member x y))]))
       
(define %append
  (%rel (h l l1 l2 l3)
        [('() l l)]
        [((cons h l1) l2 (cons h l3))
         (%append l1 l2 l3)]))

(define %select
  (%rel (x r h t)
        [(x (cons x t) t)]
        [(x (cons h t) (cons h r))
         (%select x t r)])) 

(define %subtract
  (%rel (s r h t u)
        [(s '() s)]
        [(s (cons h t) r)
         (%select h s u)
         (%subtract u t r)]))

(define %choose
  (%rel (h t n n1 c)
        [(0 (_) '()) !]
        [(n (cons h t) (cons h c))
         (%is n1 (sub1 n))
         (%choose n1 t c)]
        [(n (cons (_) t) c)
         (%choose n t c)]))

(define %permutation
  (%rel (l h t u v w)
        [('() '())]
        [(l (cons h t))
         (%append v (cons h u) l)
         (%append v u w)
         (%permutation w t)]))

(define %permute-n
  (%rel (l h t u v w n m)
        [((_) '() 0)]
        [(l (cons h t) n)
         (%append v (cons h u) l)
         (%append v u w)
         (%is m (sub1 n))
         (%permute-n w t m)]))

(define %permute
  (%rel (l h t u v w n m)
        
        ;permute all
        [('() '())]
        [(l (cons h t))
         (%append v (cons h u) l)
         (%append v u w)
         (%permute w t)]

        ;permute n
        [((_) '() 0) !]
        [(l (cons h t) n)
         (%append v (cons h u) l)
         (%append v u w)
         (%is m (sub1 n))
         (%permute w t m)]))

